       IDENTIFICATION DIVISION.
       PROGRAM-ID.  CU2INQ.
       AUTHOR.      SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2015 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1989/02/27 Simmons, Created program.
      * 1997/03/17 Simmons, Updated for SYSID.
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.

      *****************************************************************
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01  PF-ROW-23.
           05  filler           pic X(3)   value SPACES.
           05  PF-ROW-23-04     pic X(8)   value SPACES.
           05  PF-ROW-23-12     pic X(8)   value SPACES.
           05  PF-ROW-23-20     pic X(8)   value 'F3=Menu '.
           05  PF-ROW-23-28     pic X(8)   value SPACES.
           05  PF-ROW-23-36     pic X(8)   value SPACES.
           05  PF-ROW-23-44     pic X(8)   value SPACES.
           05  PF-ROW-23-52     pic X(8)   value SPACES.
           05  PF-ROW-23-60     pic X(8)   value SPACES.
           05  PF-ROW-23-68     pic X(8)   value 'F12=Esc '.
           05  filler           pic X(3)   value SPACES.
       01  EOJ-MESSAGE          pic X(50)
           value '     - Enter Tran ID . . .        completed CU2INQ'.

       01  LGTH                 pic S9(4)  comp.
       01  WORK-RESP-CODE       pic 9(08)  comp.
       01  ESDS-RESP-CODE       pic 9(08)  comp.
       01  XCTL-RESP-CODE       pic 9(08)  comp.
       01  NUMBER-WORK-16       pic 9(16)  value 0.

       01  CUSTOMER-KEY         pic X(12).
       01  MSG-LINES.
           03  MSG-DATA         pic X(78)  value LOW-VALUES.

       01  SYS-PAGE             pic X(8)   value 'CU2INQ1 '.
       01  SYS-ID               pic X(4).

       01  WORK-DATE.
           05  WORK-DATE-CC     pic X(02).
           05  WORK-DATE-YY     pic 9(02).
           05  WORK-DATE-MM     pic X(02).
           05  WORK-DATE-DD     pic 9(02).
       01  WORK-TIME.
           05  WORK-TIME-HH     pic X(02).
           05  WORK-TIME-NN     pic X(02).
           05  WORK-TIME-SS     pic X(02).
           05  WORK-TIME-TT     pic X(02).

       01  W2-DATE              PIC S9(7)  COMP-3 value 0.
       01  W2-TIME              PIC S9(7)  COMP-3 value 0.

       01  Z-WORK-12            pic X(12)  value SPACES.
       01  IX-12                pic 9(3)   value 0.
       01  WORK-V-03            pic 9(3)   value 0.

       01  PROGRAM-NAME         pic x(8)   value SPACES.

       01  WS-RESPONSE         pic S9(8)   comp.
       01  WS-REASON-CODE      pic S9(8)   comp.

       01  LOCAL-TRAN-ID       pic X(4)    value 'CUI1'.

       01  PROGRAM-FLAGS.
           05  P-FLAG-ANIM     pic X       value 'N'.
           05  P-FLAG-JOURNAL  pic X       value 'Y'.

       01  WORK-ITEMS.
           05  WS-ESD128-RIDFLD PIC S9(8)  COMP VALUE +0.
           05  WS-ESD01K-RIDFLD PIC S9(8)  COMP VALUE +0.
           05  WS-ESD350-RIDFLD PIC S9(8)  COMP VALUE +0.

       01  WORK-DATE-TIME-PK    PIC S9(15)    COMP-3 VALUE +0.
       01  WORK-DATE-TIME-ZD    PIC 9(15)     value 0.
       01  WORK-DATE-TIME-ZD-2  PIC 9(15)     value 0.
       01  WORK-DATE-TIME-ZD-3  PIC 9(15)     value 0.
       01  WORK-DELAY-SS        PIC S9(8)     COMP   VALUE +0.
       01  WORK-DELAY-VALUE     PIC 9(9)      value 0.
       01  WORK-LOOP-COUNTER    PIC 9(9)      value 0.

       01  ESD128-RECORD.
           05  ESD128-DATA      pic X(128)     value SPACES.
       01  ESD128-FILE          pic X(8)       value 'ESDSC128'.

       01  ESD01K-RECORD.
           05  ESD01K-DATA      pic X(1024)    value SPACES.
       01  ESD01K-FILE          pic X(8)       value 'ESDSC01K'.

       01  ESD350-RECORD.
           05  ESD350-DATA      pic X(350)     value SPACES.
       01  ESD350-FILE          pic X(8)       value 'ESDSC350'.

          COPY CU2INQ1.
          COPY DFHBMSCA.
          COPY DFHAID.
      *   COPY DFHEIBLK.
          COPY CUSTCB01.
          COPY PAWAITER.

      *****************************************************************
       LINKAGE SECTION.
       01  DFHCOMMAREA.
           03  LS-CUSTNO         pic X(12).
           03  filler            pic X(200).

      *****************************************************************
       PROCEDURE DIVISION.
      *    if  P-FLAG-ANIM = 'Y'
      *        CALL 'CBL_DEBUGBREAK'
      *    end-if.

           perform CLEAR-MESSAGES

           evaluate TRUE
             when EIBCALEN = ZERO
                   move SPACES       to REQNUMBO
                                        CUNUMBO
                                        CULNAMEO
                                        CUFNAMEO
                                        CUMNAMEO
                                        CUADR1O
                                        CUADR2O
                                        CUCITYO
                                        CUSTATEO
                                        CUZIPO
                                        CUPHONHO
                                        CUPHONWO
                                        CUPHONCO
                                        CULDATEO
                                        CULTIMEO
                                        CUTOKENO
                                        SYSMSG1O
                                        SYSMSG2O
                  move -1 to REQNUMBL
                  perform SEND-INQUIRY-SCREEN
             when EIBAID   = DFHPF1
                  call 'CBPIPEC1'
                  move 'Help Info should be displayed in browser'
                  to MSG-LINES
                  perform RECOVERY-ROUTINE
             when EIBAID   = DFHPF3
                  perform END-OF-PROGRAM-03
             when EIBAID   = DFHPF12
                  perform END-OF-PROGRAM-12
             when EIBAID   = DFHENTER
                  perform GET-CUSTOMER-INFORMATION
             when other
                  move 'Please use a valid customer number'
                  to MSG-LINES
                  perform RECOVERY-ROUTINE
           end-evaluate.
      *    Should never get to here...
           perform END-OF-PROGRAM-12.

      *****************************************************************
       BUILD-HEADER-INFO.
           EXEC CICS ASSIGN
                SYSID(SYS-ID)
                END-EXEC.

           move SYS-ID to SYSIDO.
           move SYS-PAGE to SYSPAGEO.
           perform Z-GET-DATE-AND-TIME.
           perform Z-GET-DATE-AND-TIME-CICS.
           exit.

      *****************************************************************
       CLEAR-MESSAGES.
           move SPACES to MSG-LINES
           move SPACES to SYSMSG1O
           exit.

      *****************************************************************
       END-OF-PROGRAM-03.
           move 'MN1FMS  ' to PROGRAM-NAME
           perform TRANSFER-CONTROL
      *    Should never get to here...
           exit.

      *****************************************************************
       END-OF-PROGRAM-12.
           EXEC CICS SEND
                FROM   (EOJ-MESSAGE)
                LENGTH (50)
                ERASE
                END-EXEC

           EXEC CICS SEND
                CONTROL FREEKB
                END-EXEC

           EXEC CICS RETURN
                END-EXEC
           exit.

      *****************************************************************
       GET-CUSTOMER-INFORMATION.
           perform GET-CUSTOMER-NUMBER
           perform GET-CUSTOMER-RECORD
           perform POSSIBLE-SPECIAL-HANDLING
           perform SEND-INQUIRY-SCREEN
      *    Should never get to here...
           exit.

      *****************************************************************
       GET-CUSTOMER-NUMBER.
           EXEC CICS RECEIVE
                MAP    ('CU2INQ1')
                MAPSET ('CU2INQ1')
                RESP(WS-RESPONSE)
                RESP2(WS-REASON-CODE)
                END-EXEC.

           if  REQNUMBL > ZERO
               move REQNUMBI to Z-WORK-12
               perform Z-RIGHT-ADJUST-Z-WORK-12
               move Z-WORK-12 to REQNUMBI
               move REQNUMBI to LS-CUSTNO
           else
               move 'Please enter a 12 digit customer number...3'
                 to MSG-LINES
               perform RECOVERY-ROUTINE
           end-if.
           exit.

      *****************************************************************
       GET-CUSTOMER-RECORD.
           move LS-CUSTNO to CUSTOMER-KEY.
           move 512       to LGTH.
           EXEC CICS read
                DATASET   ('CUSTMAST')
                INTO      (CUST-RECORD)
                LENGTH    (LGTH)
                RIDFLD    (CUSTOMER-KEY)
                KEYLENGTH (12)
                RESP      (WORK-RESP-CODE)
                END-EXEC.

      *    If the read worked the data is moved to the screen
      *
           if  WORK-RESP-CODE = ZEROS
               move CUST-NUMBER      to REQNUMBO
               move CUST-NUMBER      to CUNUMBI
               move CUST-LAST-NAME   to CULNAMEO
               move CUST-FIRST-NAME  to CUFNAMEO
               move CUST-MID-NAME    to CUMNAMEO
               move CUST-ADDRESS-1   to CUADR1O
               move CUST-ADDRESS-2   to CUADR2O
               move CUST-CITY        to CUCITYO
               move CUST-STATE       to CUSTATEO
               move CUST-POSTAL-CODE to CUZIPO
               move CUST-PHONE-HOME  to CUPHONHO
               move CUST-PHONE-WORK  to CUPHONWO
               move CUST-PHONE-CELL  to CUPHONCO
               move CUST-LADATE      to CULDATEO
               move CUST-LATIME      to CULTIMEO
               move CUST-TOKEN       to CUTOKENO
               move LOW-VALUES       to SYSMSG1O
               move LOW-VALUES       to SYSMSG2O
           else
               move SPACES           to REQNUMBO
                                        CUNUMBO
                                        CULNAMEO
                                        CUFNAMEO
                                        CUMNAMEO
                                        CUADR1O
                                        CUADR2O
                                        CUCITYO
                                        CUSTATEO
                                        CUZIPO
                                        CUPHONHO
                                        CUPHONWO
                                        CUPHONCO
                                        CULDATEO
                                        CULTIMEO
                                        CUTOKENO
                                        SYSMSG1O
                                        SYSMSG2O
                move LS-CUSTNO to MSG-LINES
                move '* Customer number not found,please try again...'
                  to MSG-LINES(14:48)
                perform RECOVERY-ROUTINE
           end-if.

      *****************************************************************
       POSSIBLE-SPECIAL-HANDLING.
      *    The following is Work-in-Progress for User Coded journaling
      *    and Tracing plus a ROLLBACK test.
      *
           evaluate LS-CUSTNO
             when '000000000232' perform WIP-RECORD-232-REQUEST
             when '000000000222' perform WIP-RECORD-222-REQUEST
             when '000000000901' perform WIP-RECORD-901-REQUEST
             when '000000000911' perform WIP-RECORD-911-REQUEST
             when '000000000921' perform WIP-RECORD-921-REQUEST
             when '000000000931' perform WIP-RECORD-931-REQUEST
             when '000000000941' perform WIP-RECORD-941-REQUEST
             when '000000000991' perform WIP-RECORD-991-REQUEST
             when '000000000992' perform WIP-RECORD-992-REQUEST
             when '000000000993' perform WIP-RECORD-993-REQUEST
             when '000000000994' perform WIP-RECORD-994-REQUEST
           end-evaluate.

           exit.

      *****************************************************************
       RECOVERY-ROUTINE.
           move MSG-LINES to SYSMSG1O.
           move -1 to REQNUMBL
           perform SEND-INQUIRY-SCREEN
      *    Should never get to here...
           exit.

      *****************************************************************
       SEND-INQUIRY-SCREEN.
           perform BUILD-HEADER-INFO
           move PF-ROW-23 to PFROW23O

           EXEC CICS SEND
                MAP    ('CU2INQ1')
                MAPSET ('CU2INQ1')
                ERASE
                END-EXEC
           move LOW-VALUES to CU2INQ1O
           EXEC CICS RETURN
                TRANSID (LOCAL-TRAN-ID)
                COMMAREA (CU2INQ1O)
                LENGTH    (32)
                END-EXEC

      *    Should never get to here...
           exit.

      *****************************************************************
       TRANSFER-CONTROL.
           EXEC CICS XCTL
                PROGRAM(PROGRAM-NAME)
                RESP(XCTL-RESP-CODE)
                END-EXEC

      *    Should never get to here...
           move 'Program not found, &&&&&&&&' to MSG-LINES.
           inspect MSG-LINES replacing first '&&&&&&&&'
                                          by PROGRAM-NAME
           move -1 to REQNUMBL.
           perform RECOVERY-ROUTINE.
      *    exit.

      *****************************************************************
       WIP-RECORD-901-REQUEST.
           perform Z-GET-DATE-AND-TIME
           move WORK-DATE             to ESD128-DATA
           move WORK-TIME             to ESD128-DATA(10:8)
           move 'RECORD 901 request'  to ESD128-DATA(20:18)
           move 'EXEC CICS SYNCPOINT' to ESD128-DATA(40:19)
           move ESD128-DATA to SYSMSG2I
           EXEC CICS SYNCPOINT
                END-EXEC
           if EIBRESP = 0
              move 'EIBRESP = 0' to SYSMSG2I(40:11)
           else
              move 'EIBRESP not = 0' to SYSMSG2I(40:15)
           end-if
           exit.

      *****************************************************************
       WIP-RECORD-911-REQUEST.
           perform Z-GET-DATE-AND-TIME
           move WORK-DATE            to ESD128-DATA
           move WORK-TIME            to ESD128-DATA(10:8)
           move 'RECORD 911 request' to ESD128-DATA(20:18)
           move 'Write to ESDSC128'  to ESD128-DATA(40:17)
           move ESD128-DATA to MSG-LINES
           EXEC CICS WRITE
               FILE   (ESD128-FILE)
               FROM   (ESD128-RECORD)
               RIDFLD (WS-ESD128-RIDFLD)
               RBA
               LENGTH (LENGTH OF ESD128-RECORD)
               RESP   (ESDS-RESP-CODE)
               END-EXEC
           if  ESDS-RESP-CODE not = 0
               add  ESDS-RESP-CODE to ZERO giving NUMBER-WORK-16
               move NUMBER-WORK-16  to MSG-LINES(63:16)
               perform RECOVERY-ROUTINE
           end-if

           exit.

      *****************************************************************
       WIP-RECORD-921-REQUEST.
           perform Z-GET-DATE-AND-TIME
           move WORK-DATE            to ESD128-DATA
           move WORK-TIME            to ESD128-DATA(10:8)
           move 'RECORD 921 request' to ESD128-DATA(20:18)
           move 'ROLLBACK'           to SYSMSG2I(40:8)
           move ESD128-DATA to SYSMSG2I
           EXEC CICS SYNCPOINT
                ROLLBACK
                END-EXEC
           if EIBRESP = 0
              move 'EIBRESP = 0' to SYSMSG2I(40:11)
           else
              move 'EIBRESP not = 0' to SYSMSG2I(40:15)
           end-if

           exit.

      *****************************************************************
       WIP-RECORD-931-REQUEST.
           perform Z-GET-DATE-AND-TIME
           move WORK-DATE            to ESD128-DATA
           move WORK-TIME            to ESD128-DATA(10:8)
           move 'RECORD 931 request' to ESD128-DATA(20:18)
           move ESD128-DATA to SYSMSG2I

           EXEC CICS SYNCPOINT
                END-EXEC

           EXEC CICS WRITE
                FILE   (ESD128-FILE)
                FROM   (ESD128-RECORD)
                RIDFLD (WS-ESD128-RIDFLD)
                RBA
                LENGTH (LENGTH OF ESD128-RECORD)
                RESP   (ESDS-RESP-CODE)
                END-EXEC

           EXEC CICS DELAY
                FOR SECONDS (45)
                END-EXEC

           EXEC CICS SYNCPOINT
                ROLLBACK
                END-EXEC

           exit.

      *****************************************************************
       WIP-RECORD-941-REQUEST.
           perform Z-GET-DATE-AND-TIME
           move WORK-DATE            to ESD128-DATA
           move WORK-TIME            to ESD128-DATA(10:8)
           move 'RECORD 941 request' to ESD128-DATA(20:18)
           move ESD128-DATA to SYSMSG2I

           EXEC CICS SYNCPOINT
                ROLLBACK
                END-EXEC

           exit.

      *****************************************************************
       WIP-RECORD-991-REQUEST.
           EXEC CICS ASKTIME ABSTIME(WORK-DATE-TIME-PK) END-EXEC
           add WORK-DATE-TIME-PK to ZERO giving WORK-DATE-TIME-ZD
           move 'WIP-RECORD-991-REQUEST-1=' to ESD128-DATA
           move WORK-DATE-TIME-ZD           to ESD128-DATA(26:15)

           EXEC CICS DELAY FOR SECONDS(2) END-EXEC

           EXEC CICS ASKTIME ABSTIME(WORK-DATE-TIME-PK) END-EXEC
           add WORK-DATE-TIME-PK to ZERO giving WORK-DATE-TIME-ZD
           move WORK-DATE-TIME-ZD           to ESD128-DATA(44:15)
           move ESD128-DATA to SYSMSG1O.

           EXEC CICS WRITE
                FILE   (ESD128-FILE)
                FROM   (ESD128-RECORD)
                RIDFLD (WS-ESD128-RIDFLD)
                RBA
                LENGTH (LENGTH OF ESD128-RECORD)
                RESP   (ESDS-RESP-CODE)
                END-EXEC

           EXEC CICS DELAY FOR SECONDS(4) END-EXEC

           EXEC CICS ASKTIME ABSTIME(WORK-DATE-TIME-PK) END-EXEC
           add WORK-DATE-TIME-PK to ZERO giving WORK-DATE-TIME-ZD
           move SPACES                       to ESD128-DATA
           move 'WIP-RECORD-991-REQUEST-2='  to ESD128-DATA
           move WORK-DATE-TIME-ZD            to ESD128-DATA(26:15)
           move ESD128-DATA to SYSMSG2O

           EXEC CICS WRITE
                FILE   (ESD128-FILE)
                FROM   (ESD128-RECORD)
                RIDFLD (WS-ESD128-RIDFLD)
                RBA
                LENGTH (LENGTH OF ESD128-RECORD)
                RESP   (ESDS-RESP-CODE)
                END-EXEC
           exit.

      *****************************************************************
       WIP-RECORD-992-REQUEST.
           EXEC CICS ASKTIME ABSTIME(WORK-DATE-TIME-PK) END-EXEC
           add WORK-DATE-TIME-PK to ZERO giving WORK-DATE-TIME-ZD
           move 'WIP-RECORD-992-REQUEST-1=' to ESD128-DATA
           move WORK-DATE-TIME-ZD           to ESD128-DATA(26:15)

           add 1 to ZERO giving WORK-DELAY-SS
           move ZERO to WORK-LOOP-COUNTER
           perform 10 times
               EXEC CICS DELAY FOR SECONDS(WORK-DELAY-SS) END-EXEC
               add 1 to WORK-LOOP-COUNTER
           end-perform

           EXEC CICS ASKTIME ABSTIME(WORK-DATE-TIME-PK) END-EXEC
           add WORK-DATE-TIME-PK to ZERO giving WORK-DATE-TIME-ZD-2
           move WORK-DATE-TIME-ZD-2           to ESD128-DATA(44:15)
           if  WORK-DATE-TIME-ZD-2 > WORK-DATE-TIME-ZD
               subtract WORK-DATE-TIME-ZD from WORK-DATE-TIME-ZD-2
                 giving WORK-DATE-TIME-ZD-3
               move WORK-DATE-TIME-ZD-3       to ESD128-DATA(62:15)
           else
               move '???????????????'         to ESD128-DATA(62:15)
           end-if
           move WORK-LOOP-COUNTER             to ESD128-DATA(80:9)
           move ESD128-DATA to SYSMSG2O

           EXEC CICS WRITE
                FILE   (ESD128-FILE)
                FROM   (ESD128-RECORD)
                RIDFLD (WS-ESD128-RIDFLD)
                RBA
                LENGTH (LENGTH OF ESD128-RECORD)
                RESP   (ESDS-RESP-CODE)
                END-EXEC

           exit.

      *****************************************************************
       WIP-RECORD-993-REQUEST.
           add 2 to ZERO giving WORK-DELAY-SS
           add 2 to ZERO giving WORK-DELAY-VALUE
           move ZERO to WORK-LOOP-COUNTER
           perform 10 times
             EXEC CICS ASKTIME ABSTIME(WORK-DATE-TIME-PK) END-EXEC
             add WORK-DATE-TIME-PK to ZERO giving WORK-DATE-TIME-ZD
             move 'WIP-RECORD-993-REQUEST-1=' to ESD128-DATA
             move WORK-DATE-TIME-ZD           to ESD128-DATA(26:15)

             EXEC CICS DELAY FOR SECONDS(1) END-EXEC
             add 1 to WORK-LOOP-COUNTER

             EXEC CICS ASKTIME ABSTIME(WORK-DATE-TIME-PK) END-EXEC
             add WORK-DATE-TIME-PK to ZERO giving WORK-DATE-TIME-ZD-2
             move WORK-DATE-TIME-ZD-2           to ESD128-DATA(44:15)
             if  WORK-DATE-TIME-ZD-2 > WORK-DATE-TIME-ZD
                 subtract WORK-DATE-TIME-ZD from WORK-DATE-TIME-ZD-2
                   giving WORK-DATE-TIME-ZD-3
                 move WORK-DATE-TIME-ZD-3       to ESD128-DATA(62:15)
             else
                 move '???????????????'         to ESD128-DATA(62:15)
             end-if
             move WORK-LOOP-COUNTER             to ESD128-DATA(80:9)
             move WORK-DELAY-VALUE              to ESD128-DATA(90:9)

             EXEC CICS WRITE
                  FILE   (ESD128-FILE)
                  FROM   (ESD128-RECORD)
                  RIDFLD (WS-ESD128-RIDFLD)
                  RBA
                  LENGTH (LENGTH OF ESD128-RECORD)
                  RESP   (ESDS-RESP-CODE)
                  END-EXEC
           end-perform
           move ESD128-DATA to SYSMSG2O
           exit.

      *****************************************************************
       WIP-RECORD-994-REQUEST.
           add 1 to ZERO giving WORK-DELAY-SS
           move ZERO to WORK-LOOP-COUNTER
           add 11 to ZERO giving MFWAITER-LENGTH
           move '00:00:01:00' to MFWAITER-TIME
           perform 10 times
             EXEC CICS ASKTIME ABSTIME(WORK-DATE-TIME-PK) END-EXEC
             add WORK-DATE-TIME-PK to ZERO giving WORK-DATE-TIME-ZD
             move 'WIP-RECORD-994-REQUEST-1=' to ESD128-DATA
             move WORK-DATE-TIME-ZD           to ESD128-DATA(26:15)

             call 'MFWAITER' using MFWAITER-PASS-AREA
             add 1 to WORK-LOOP-COUNTER

             EXEC CICS ASKTIME ABSTIME(WORK-DATE-TIME-PK) END-EXEC
             add WORK-DATE-TIME-PK to ZERO giving WORK-DATE-TIME-ZD-2
             move WORK-DATE-TIME-ZD-2           to ESD128-DATA(44:15)
             if  WORK-DATE-TIME-ZD-2 > WORK-DATE-TIME-ZD
                 subtract WORK-DATE-TIME-ZD from WORK-DATE-TIME-ZD-2
                   giving WORK-DATE-TIME-ZD-3
                 move WORK-DATE-TIME-ZD-3       to ESD128-DATA(62:15)
             else
                 move '???????????????'         to ESD128-DATA(62:15)
             end-if
             move WORK-LOOP-COUNTER             to ESD128-DATA(80:9)

             EXEC CICS WRITE
                  FILE   (ESD128-FILE)
                  FROM   (ESD128-RECORD)
                  RIDFLD (WS-ESD128-RIDFLD)
                  RBA
                  LENGTH (LENGTH OF ESD128-RECORD)
                  RESP   (ESDS-RESP-CODE)
                  END-EXEC
           end-perform
           move ESD128-DATA to SYSMSG2O
           exit.

      *****************************************************************
       WIP-RECORD-232-REQUEST.
           perform Z-GET-DATE-AND-TIME
           move WORK-DATE            to ESD128-DATA
           move WORK-TIME            to ESD128-DATA(10:8)
           move 'RECORD 232 request' to ESD128-DATA(20:18)
           move 'Write to ESDSC128'  to ESD128-DATA(40:17)

           move ESD128-DATA to SYSMSG2I

           EXEC CICS WRITE
               FILE   (ESD128-FILE)
               FROM   (ESD128-RECORD)
               RIDFLD (WS-ESD128-RIDFLD)
               RBA
               LENGTH (LENGTH OF ESD128-RECORD)
               RESP   (ESDS-RESP-CODE)
               END-EXEC
           if  ESDS-RESP-CODE not = 0
               add  ESDS-RESP-CODE to ZERO giving NUMBER-WORK-16
               move NUMBER-WORK-16  to MSG-LINES(63:16)
               perform RECOVERY-ROUTINE
           end-if

           move WORK-DATE            to ESD01K-DATA
           move WORK-TIME            to ESD01K-DATA(10:8)
           move 'RECORD 232 request' to ESD01K-DATA(20:18)
           move 'Write to ESDSC01K'  to ESD01K-DATA(40:17)
           move ESD01K-DATA to SYSMSG2I

           EXEC CICS WRITE
               FILE   (ESD01K-FILE)
               FROM   (ESD01K-RECORD)
               RIDFLD (WS-ESD01K-RIDFLD)
               RBA
               LENGTH (LENGTH OF ESD01K-RECORD)
               RESP   (ESDS-RESP-CODE)
               END-EXEC
           if  ESDS-RESP-CODE not = 0
               add  ESDS-RESP-CODE to ZERO giving NUMBER-WORK-16
               move NUMBER-WORK-16  to MSG-LINES(63:16)
               go to RECOVERY-ROUTINE
           end-if

           add 1 to ZERO giving WORK-V-03
           perform 3 times
              perform Z-GET-DATE-AND-TIME
              move WORK-DATE            to ESD350-DATA
              move WORK-TIME            to ESD350-DATA(10:8)
              move 'RECORD 232 request' to ESD350-DATA(20:18)
              move 'Write to ESDSC350'  to ESD350-DATA(40:17)
              move WORK-V-03            to ESD350-DATA(60:3)
              move ESD350-DATA to SYSMSG2I
              EXEC CICS WRITE
                  FILE   (ESD350-FILE)
                  FROM   (ESD350-RECORD)
                  RIDFLD (WS-ESD350-RIDFLD)
                  RBA
                  LENGTH (LENGTH OF ESD350-RECORD)
                  RESP   (ESDS-RESP-CODE)
                  END-EXEC
              if  ESDS-RESP-CODE not = 0
                  add  ESDS-RESP-CODE to ZERO giving NUMBER-WORK-16
                  move NUMBER-WORK-16  to MSG-LINES(1:16)
                  move 'ESDS-RESP-CODE not ZERO' to MSG-LINES(20:23)
                  go to RECOVERY-ROUTINE
              end-if
              add 1 to WORK-V-03
           end-perform

      *    EXEC CICS UNLOCK
      *        DATASET (ESD350-FILE)
      *        END-EXEC
      *    if  ESDS-RESP-CODE not = 0
      *        add  ESDS-RESP-CODE to ZERO giving NUMBER-WORK-16
      *        move NUMBER-WORK-16  to MSG-LINES(1:16)
      *        move 'ESDS-RESP-CODE not ZERO' to MSG-LINES(20:23)
      *        go to RECOVERY-ROUTINE
      *    end-if

      *    EXEC CICS DELAY
      *         FOR SECONDS (45)
      *         END-EXEC

      *    perform WIP-RECORD-222-REQUEST

           exit.

      *****************************************************************
       WIP-RECORD-233-REQUEST.
           perform Z-GET-DATE-AND-TIME
           move WORK-DATE            to ESD128-DATA
           move WORK-TIME            to ESD128-DATA(10:8)
           move 'RECORD 233 request' to ESD128-DATA(20:18)
           move 'Write to ESDSC128'  to ESD128-DATA(40:17)

           move ESD128-DATA to SYSMSG2I

           EXEC CICS WRITE
               FILE   (ESD128-FILE)
               FROM   (ESD128-RECORD)
               RIDFLD (WS-ESD128-RIDFLD)
               RBA
               LENGTH (LENGTH OF ESD128-RECORD)
               RESP   (ESDS-RESP-CODE)
               END-EXEC
           if  ESDS-RESP-CODE not = 0
               add  ESDS-RESP-CODE to ZERO giving NUMBER-WORK-16
               move NUMBER-WORK-16  to MSG-LINES(63:16)
               perform RECOVERY-ROUTINE
           end-if

           perform WIP-RECORD-232-REQUEST
           perform WIP-RECORD-222-REQUEST
           exit.

      *****************************************************************
       WIP-RECORD-222-REQUEST.
           perform Z-GET-DATE-AND-TIME
           move WORK-DATE            to SYSMSG2I
           move WORK-TIME            to SYSMSG2I(10:8)
           move 'RECORD 222 request' to SYSMSG2I(20:18)
           move 'ROLLBACK'           to SYSMSG2I(40:8)
           EXEC CICS SYNCPOINT
                ROLLBACK
                END-EXEC
           if EIBRESP = 0
              move 'EIBRESP = 0' to SYSMSG2I(40:11)
           else
              move 'EIBRESP not = 0' to SYSMSG2I(40:15)
           end-if

           exit.

      *****************************************************************
      * Delete all characters to the right of the first space then
      * right-adjust with zero fill. This routine works with a single,
      * twelve character field and does not require a work area.
      *****************************************************************
       Z-RIGHT-ADJUST-Z-WORK-12.
           inspect Z-WORK-12
                   replacing CHARACTERS by ' ' after initial ' '
           perform until Z-WORK-12(12:1) not = SPACE
               if  Z-WORK-12(12:1) = SPACE
                   add 11 to ZERO giving IX-12
                   perform 11 times
                     move Z-WORK-12(IX-12:1) to Z-WORK-12(IX-12 + 1:1)
                     subtract 1 from IX-12
                   end-perform
                   move ZERO to Z-WORK-12(1:1)
               end-if
           end-perform
           exit.

      *****************************************************************
       Z-GET-DATE-AND-TIME.
           accept WORK-DATE from DATE YYYYMMDD
           accept WORK-TIME from TIME

           move 'ccyy/mm/dd'   to SYSDATEO
           move WORK-DATE(1:4) to SYSDATEO(1:4)
           move WORK-DATE(5:2) to SYSDATEO(6:2)
           move WORK-DATE(7:2) to SYSDATEO(9:2)

           move 'hh:mm:ss:dd'  to SYSTIMEO
           move WORK-TIME(1:2) to SYSTIMEO(1:2)
           move WORK-TIME(3:2) to SYSTIMEO(4:2)
           move WORK-TIME(5:2) to SYSTIMEO(7:2)
           move WORK-TIME(7:2) to SYSTIMEO(10:2)

           exit.

      *****************************************************************
       Z-GET-DATE-AND-TIME-CICS.
           EXEC CICS ASKTIME END-EXEC
           MOVE EIBDATE TO W2-DATE
           MOVE EIBTIME TO W2-TIME
           exit.
